#!/usr/bin/env python

# 2 functions shamelessly ripped off from
# /usr/lib/ubiquity/ubiquity/frontend/gtk_ui.py

import sys
import os
sys.path.append("/usr/lib/ubiquity/") 
sys.path.append("/usr/lib/ubiquity/ubiquity/") 
import gconftool # depends: ubiquity
import atexit  # depends: ubiquity

class gnome_volume_manager(object):
    """Disables and enables GNOME's auto-mounting of removable devices
    Tested on Ubuntu Hardy Heron 8.04 (LTS)
    """

    def disable_volume_manager(self):
        gvm_root = '/desktop/gnome/volume_manager'
        gvm_automount_drives = '%s/automount_drives' % gvm_root
        gvm_automount_media = '%s/automount_media' % gvm_root
        volumes_visible = '/apps/nautilus/desktop/volumes_visible'
        media_automount = '/apps/nautilus/preferences/media_automount'
        media_automount_open = '/apps/nautilus/preferences/media_automount_open'
        media_autorun_never = '/apps/nautilus/preferences/media_autorun_never'
        self.gconf_previous = {}
        for gconf_key in (gvm_automount_drives, gvm_automount_media,
                          volumes_visible, media_automount, media_automount_open):
            self.gconf_previous[gconf_key] = gconftool.get(gconf_key)
            if self.gconf_previous[gconf_key] != 'false':
                gconftool.set(gconf_key, 'bool', 'false')
        for gconf_key in (media_autorun_never,):
            self.gconf_previous[gconf_key] = gconftool.get(gconf_key)
            if self.gconf_previous[gconf_key] != 'true':
                gconftool.set(gconf_key, 'bool', 'true')
        #self.thunar_previous = self.thunar_set_volmanrc(
        #    {'AutomountDrives': 'FALSE', 'AutomountMedia': 'FALSE'})
        atexit.register(self.enable_volume_manager)
        print "Disabled GNOME automount"

    def enable_volume_manager(self):
        """Works only if disable_volume_manager() was called before on the same object!"""
        gvm_root = '/desktop/gnome/volume_manager'
        gvm_automount_drives = '%s/automount_drives' % gvm_root
        gvm_automount_media = '%s/automount_media' % gvm_root
        volumes_visible = '/apps/nautilus/desktop/volumes_visible'
        media_automount = '/apps/nautilus/preferences/media_automount'
        media_automount_open = '/apps/nautilus/preferences/media_automount_open'
        media_autorun_never = '/apps/nautilus/preferences/media_autorun_never'
        for gconf_key in (gvm_automount_drives, gvm_automount_media,
                          volumes_visible,
                          media_automount, media_automount_open):
            if self.gconf_previous[gconf_key] == '':
                gconftool.unset(gconf_key)
            elif self.gconf_previous[gconf_key] != 'false':
                gconftool.set(gconf_key, 'bool',
                              self.gconf_previous[gconf_key])
        for gconf_key in (media_autorun_never,):
            if self.gconf_previous[gconf_key] == '':
                gconftool.unset(gconf_key)
            elif self.gconf_previous[gconf_key] != 'true':
                gconftool.set(gconf_key, 'bool',
                              self.gconf_previous[gconf_key])
        print "Re-enabled GNOME automount"

if __name__ == "__main__":
    """Testing"""
    mgr = gnome_volume_manager()
    mgr.disable_volume_manager()
    mgr.enable_volume_manager()
